<template>
    <div :class="{
        'block': true,
        'block--empty': showPlaceholder && !hasData,
    }">
        <template v-if="showPlaceholder && !hasData">
            <p class="block__placeholder">
                {{ placeholder }}
            </p>
            <svg width="100%" height="100%" viewBox="0 0 100% 100%" fill="none" xmlns="http://www.w3.org/2000/svg">
                <rect width="100%" height="100%" stroke="#9A9DA4" stroke-width="4" stroke-linecap="round"
                    stroke-dasharray="32 32" />
            </svg>
        </template>
        <template v-else>
            <div class="header-wrapper">
                <search-input v-if="searchable" class="search-input" v-model="search" placeholder="Search..." />
                <h2 v-if="title" class="heading">{{ title }}</h2>
                <div v-if="subtitle" class="subheading-container">
                    <h3 class="subheading">{{ subtitle }}</h3>
                    <sorting v-if="sortable" :order="currentSortOrder" @change-order="onSortOrderChange">
                    </sorting>
                </div>
            </div>
            <ul class="content" ref="content">
                <li :class="{
                    'content-item': true,
                    'content-item--active': item === selected
                }" @click="onSelect(item)" v-for="(item, idx) in filteredData" :key="idx">
                    {{ renderCallback(item) }}
                </li>
            </ul>
        </template>
    </div>
</template>

<script lang="ts">
import { computed, toRefs, ref, PropType, defineComponent } from 'vue';
import SearchInput from './SearchInput.vue';
import Sorting from './Sorting.vue';
import { Order } from '@/shared/types';

export default defineComponent({
    components: { SearchInput, Sorting },
    props: {
        sortable: {
            type: Boolean,
            default: false,
        },
        sortOrder: {
            type: String as PropType<"asc" | "desc" | "none">,
            default: 'asc',
        },
        title: String,
        subtitle: String,
        selected: {
            type: String,
            required: false
        },
        showPlaceholder: {
            type: Boolean,
            default: true,
        },
        placeholder: String,
        searchable: {
            type: Boolean,
            default: false,
        },
        data: {
            type: Array as PropType<unknown[]>,
            default: () => [],
        },
        sortCallback: {
            type: Function,
            default: (order: Order) => (i1: unknown, i2: unknown) => {
                switch (order) {
                    case 'asc': {
                        if (typeof i1 === 'string' && typeof i2 === 'string') {
                            return i1.toLowerCase().localeCompare(i2.toLowerCase());
                        }
                        if (typeof i1 === 'number' && typeof i2 === 'number') {
                            return i1 - i2;
                        }
                        return 0;
                    }
                    case 'desc': {
                        if (typeof i1 === 'string' && typeof i2 === 'string') {
                            return i2.toLowerCase().localeCompare(i1.toLowerCase());
                        }
                        if (typeof i1 === 'number' && typeof i2 === 'number') {
                            return i2 - i1;
                        }
                        return 0;
                    }
                    case 'none':
                    default: {
                        return 0;
                    }
                }
            }
        },
        renderCallback: {
            type: Function,
            default: (item: unknown) => item
        },
        filterCallback: {
            type: Function,
            default: (filterValue: string) => (item: unknown) => (item as string).toLowerCase().includes(filterValue.toLowerCase())
        },
    },
    emits: ['item-selected'],
    setup(props, { emit }) {
        const { data } = toRefs(props);
        const search = ref('');
        const currentSortOrder = ref(props.sortOrder);
        const hasData = computed(() => data.value.length !== 0);

        const filteredData = computed(() => {
            const sortBy = props.sortCallback(currentSortOrder.value); 
            const filterCb = props.filterCallback(search.value);
            return data.value.filter(filterCb).sort(sortBy);
        });

        const onSelect = (item: unknown) => {
            emit('item-selected', item as string);
        }

        const onSortOrderChange = (order: Order) => {
            currentSortOrder.value = order;
        }

        return {
            hasData,
            onSelect,
            filteredData,
            search,
            currentSortOrder,
            onSortOrderChange
        }
    },
});
</script>

<style lang="scss">
.header-wrapper {
    padding: 24px;
}

.heading {
    margin-bottom: 32px;
}

.block {
    overflow-y: auto;
    position: relative;

    &::-webkit-scrollbar-track {
        background-color: transparent;
    }

    &::-webkit-scrollbar {
        width: 4px;
    }

    &::-webkit-scrollbar-thumb {
        background-color: var(--primary);
    }

    &__placeholder {
        color: var(--gray-dark);
        font-weight: 400;
        font-size: 14px;
    }

    &--empty {
        display: flex;
        justify-content: center;
        align-items: center;
    }

    &>svg {
        position: absolute;
        top: 0;
        right: 0;
        bottom: 0;
        left: 0;
        z-index: 1;
        height: 100%;
        width: 100%;
    }

    .search-input {
        &-wrapper {
            width: 288px;
        }
    }
}

.subheading-container {
    display: flex;
    align-items: center;
}

.content {
    padding-left: 0;
    list-style: none;
    scrollbar-color: var(--primary) var(--light);
    scrollbar-width: thin;
}

.content-item {
    padding: 20px 24px;
    border-top: 1px solid #E2E4EA;
    color: var(--gray-dark-2);
    font-size: 12px;
    font-weight: 400;

    &--active {
        color: var(--primary);
    }

    &:hover {
        background-color: #F8F8FB;
        cursor: pointer;
    }
}
</style>